/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-nao-msgs-0.3.0-0oneiric-20140821-0858/msg/WordRecognized.msg
 *
 */


#ifndef NAO_MSGS_MESSAGE_WORDRECOGNIZED_H
#define NAO_MSGS_MESSAGE_WORDRECOGNIZED_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace nao_msgs
{
template <class ContainerAllocator>
struct WordRecognized_
{
  typedef WordRecognized_<ContainerAllocator> Type;

  WordRecognized_()
    : words()
    , confidence_values()  {
    }
  WordRecognized_(const ContainerAllocator& _alloc)
    : words(_alloc)
    , confidence_values(_alloc)  {
    }



   typedef std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > , typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::other >  _words_type;
  _words_type words;

   typedef std::vector<float, typename ContainerAllocator::template rebind<float>::other >  _confidence_values_type;
  _confidence_values_type confidence_values;




  typedef boost::shared_ptr< ::nao_msgs::WordRecognized_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::nao_msgs::WordRecognized_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct WordRecognized_

typedef ::nao_msgs::WordRecognized_<std::allocator<void> > WordRecognized;

typedef boost::shared_ptr< ::nao_msgs::WordRecognized > WordRecognizedPtr;
typedef boost::shared_ptr< ::nao_msgs::WordRecognized const> WordRecognizedConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::nao_msgs::WordRecognized_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::nao_msgs::WordRecognized_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace nao_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'nav_msgs': ['/opt/ros/groovy/share/nav_msgs/cmake/../msg'], 'nao_msgs': ['/tmp/buildd/ros-groovy-nao-msgs-0.3.0-0oneiric-20140821-0858/msg', '/tmp/buildd/ros-groovy-nao-msgs-0.3.0-0oneiric-20140821-0858/obj-i686-linux-gnu/devel/share/nao_msgs/msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/groovy/share/actionlib_msgs/cmake/../msg'], 'trajectory_msgs': ['/opt/ros/groovy/share/trajectory_msgs/cmake/../msg'], 'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::nao_msgs::WordRecognized_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::nao_msgs::WordRecognized_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nao_msgs::WordRecognized_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nao_msgs::WordRecognized_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nao_msgs::WordRecognized_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nao_msgs::WordRecognized_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::nao_msgs::WordRecognized_<ContainerAllocator> >
{
  static const char* value()
  {
    return "29134437cd61021f75f35f21b72b7eab";
  }

  static const char* value(const ::nao_msgs::WordRecognized_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x29134437cd61021fULL;
  static const uint64_t static_value2 = 0x75f35f21b72b7eabULL;
};

template<class ContainerAllocator>
struct DataType< ::nao_msgs::WordRecognized_<ContainerAllocator> >
{
  static const char* value()
  {
    return "nao_msgs/WordRecognized";
  }

  static const char* value(const ::nao_msgs::WordRecognized_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::nao_msgs::WordRecognized_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# Message emitted by Nao speech recognition.\n\
# It contains the list of words recognized and confidence values\n\
# Both arrays are of the same length\n\
string[] words\n\
float32[] confidence_values\n\
";
  }

  static const char* value(const ::nao_msgs::WordRecognized_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::nao_msgs::WordRecognized_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.words);
      stream.next(m.confidence_values);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct WordRecognized_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::nao_msgs::WordRecognized_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::nao_msgs::WordRecognized_<ContainerAllocator>& v)
  {
    s << indent << "words[]" << std::endl;
    for (size_t i = 0; i < v.words.size(); ++i)
    {
      s << indent << "  words[" << i << "]: ";
      Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.words[i]);
    }
    s << indent << "confidence_values[]" << std::endl;
    for (size_t i = 0; i < v.confidence_values.size(); ++i)
    {
      s << indent << "  confidence_values[" << i << "]: ";
      Printer<float>::stream(s, indent + "  ", v.confidence_values[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // NAO_MSGS_MESSAGE_WORDRECOGNIZED_H
